function varargout = PutSiteCleavageGUI(varargin)
% PUTSITECLEAVAGEGUI MATLAB code for PutSiteCleavageGUI.fig
%      PUTSITECLEAVAGEGUI, by itself, creates a new PUTSITECLEAVAGEGUI or raises the existing
%      singleton*.
%
%      H = PUTSITECLEAVAGEGUI returns the handle to a new PUTSITECLEAVAGEGUI or the handle to
%      the existing singleton*.
%
%      PUTSITECLEAVAGEGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PUTSITECLEAVAGEGUI.M with the given input arguments.
%
%      PUTSITECLEAVAGEGUI('Property','Value',...) creates a new PUTSITECLEAVAGEGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before PutSiteCleavageGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to PutSiteCleavageGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help PutSiteCleavageGUI

% Last Modified by GUIDE v2.5 22-Dec-2016 15:15:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @PutSiteCleavageGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @PutSiteCleavageGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before PutSiteCleavageGUI is made visible.
function PutSiteCleavageGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to PutSiteCleavageGUI (see VARARGIN)

% Choose default command line output for PutSiteCleavageGUI
handles.output = hObject;



% Update handles structure
guidata(hObject, handles);


% Adds in graphics
imshow('PlattLogo2.jpg', 'Parent', handles.axes6);
imshow('ProteaseAseSchematic.jpg', 'Parent', handles.axes7);


% --- Outputs from this function are returned to the command line.
function varargout = PutSiteCleavageGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in calcScoresButton.
function calcScoresButton_Callback(hObject, eventdata, handles)
% hObject    handle to calcScoresButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Getting loaded components
 matrixLink = get(handles.SpecMat, 'string');
 if(strncmpi(matrixLink, 'https://', 5))
     matrixLink = strrep(matrixLink, 'https://merops.sanger.ac.uk/cgi-bin/pepsum?id=', ...
         'http://meghan.ferrall-fairbanks.com/merops_data/');
 elseif (strncmpi(matrixLink, 'http://', 4))
     matrixLink = strrep(matrixLink, 'http://merops.sanger.ac.uk/cgi-bin/pepsum?id=', ...
         'http://meghan.ferrall-fairbanks.com/merops_data/');    
 else
      matrixLink = strrep(matrixLink, 'merops.sanger.ac.uk/cgi-bin/pepsum?id=', ...
     'http://meghan.ferrall-fairbanks.com/merops_data/'); 
 end
 
 matrixLink = strcat(matrixLink, '.csv');
 specmat = getSpecifMat(matrixLink);

sequence = get(handles.AAseq, 'string');

% Removes any spaces from sequence
% temp2 = sequence;
% temp1 = '';
% 
% while ~strcmp(temp1, temp2)
%     temp1 = temp2;
%     temp2 = regexprep(temp1, ' ', '');
% end
%sequence = temp2;

% saving three components into matfile needed for csa_calscore 
% followed along with example: 
% http://www.mathworks.com/help/matlab/import_export/load-parts-of-variables-from-mat-files.html
save MatForScoring.mat sequence specmat -v7.3;

% create output file name
% csa_analyze will store the scoring of cleavage sites in this file
%loadedData = load('MatForScoring.mat');
outputFileName = strcat(get(handles.protease, 'string'), 'on', get(handles.substrate, 'string'));

% convert bounds from strings to numbers
lowB = str2num(get(handles.lowBound, 'string'));
highB = str2num(get(handles.highBound, 'string'));

% account for if something weird is entered or if nothing is entered
if  isempty(lowB)
    lowB = 1;
elseif (lowB < 1) || (lowB > 8)
    lowB = 1;
end 

if  isempty(highB)
    highB = 8;
elseif (highB < 1) || (highB > 8)
    highB = 8;
end

% run csa_analyze code
% looking at all 8 amino acid combinations
csa_analyze('MatForScoring.mat', outputFileName, lowB, highB)


function SpecMat_Callback(hObject, eventdata, handles)
% hObject    handle to SpecMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SpecMat as text
%        str2double(get(hObject,'String')) returns contents of SpecMat as a double


% --- Executes during object creation, after setting all properties.
function SpecMat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SpecMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function AAseq_Callback(hObject, eventdata, handles)
% hObject    handle to AAseq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of AAseq as text
%        str2double(get(hObject,'String')) returns contents of AAseq as a double


% --- Executes during object creation, after setting all properties.
function AAseq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AAseq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NTseq_Callback(hObject, eventdata, handles)
% hObject    handle to NTseq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NTseq as text
%        str2double(get(hObject,'String')) returns contents of NTseq as a double


% --- Executes during object creation, after setting all properties.
function NTseq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NTseq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in loadDataButton.
function loadDataButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadDataButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Getting loaded components
 matrixLink = get(handles.SpecMat, 'string');
 if(strncmpi(matrixLink, 'https://', 5))
     matrixLink = strrep(matrixLink, 'https://merops.sanger.ac.uk/cgi-bin/pepsum?id=', ...
         'http://meghan.ferrall-fairbanks.com/merops_data/');
 elseif (strncmpi(matrixLink, 'http://', 4))
     matrixLink = strrep(matrixLink, 'http://merops.sanger.ac.uk/cgi-bin/pepsum?id=', ...
         'http://meghan.ferrall-fairbanks.com/merops_data/');    
 else
      matrixLink = strrep(matrixLink, 'merops.sanger.ac.uk/cgi-bin/pepsum?id=', ...
     'http://meghan.ferrall-fairbanks.com/merops_data/'); 
 end
matrixLink = strcat(matrixLink, '.csv');
SpecMatr = getSpecifMat(matrixLink);
AminoAcidSeq = get(handles.AAseq, 'string');

% saving three components into matfile needed for csa_calscore 
% followed along with example: 
% http://www.mathworks.com/help/matlab/import_export/load-parts-of-variables-from-mat-files.html
save MatForScoring.mat SpecMatr AminoAcidSeq -v7.3;



function protease_Callback(hObject, eventdata, handles)
% hObject    handle to protease (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% 

% name of the cannibal proteases
get(handles.protease, 'string');

% Hints: get(hObject,'String') returns contents of protease as text
%        str2double(get(hObject,'String')) returns contents of protease as a double


% --- Executes during object creation, after setting all properties.
function protease_CreateFcn(hObject, eventdata, handles)
% hObject    handle to protease (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function substrate_Callback(hObject, eventdata, handles)
% hObject    handle to substrate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% name of the substrate proteases
get(handles.substrate, 'string');

% Hints: get(hObject,'String') returns contents of substrate as text
%        str2double(get(hObject,'String')) returns contents of substrate as a double


% --- Executes during object creation, after setting all properties.
function substrate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to substrate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function lowBound_Callback(hObject, eventdata, handles)
% hObject    handle to lowBound (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of lowBound as text
%        str2double(get(hObject,'String')) returns contents of lowBound as a double
get(handles.lowBound, 'string');

% --- Executes during object creation, after setting all properties.
function lowBound_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lowBound (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function highBound_Callback(hObject, eventdata, handles)
% hObject    handle to highBound (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of highBound as text
%        str2double(get(hObject,'String')) returns contents of highBound as a double
get(handles.highBound, 'string');

% --- Executes during object creation, after setting all properties.
function highBound_CreateFcn(hObject, eventdata, handles)
% hObject    handle to highBound (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function axes6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes6
axes(hObject)
imshow('PlattLogo2.jpg')

% --- Executes during object creation, after setting all properties.
function axes7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes7
axes(hObject)
imshow('ProteaseAseSchematic.jpg')
